﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Printing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Drawing;
namespace 多文档编辑器
{
    public partial class MainForm : Form
    {
        private int wCount = 0;
        private RichTextBoxStreamType oldFileType;
        private DocForm doc;
        private DrawForm drawform;

        private static DocForm docSend;
        private string fileName = string.Empty;
        private string filePath = string.Empty;

        List<DocForm> listDocForm = new List<DocForm>();

        string _connectionString = string.Format(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source={0}\FileData.mdb", Environment.CurrentDirectory);

        public MainForm()
        {
            InitializeComponent();
        }

        public static DocForm GetDocTrun()
        {
            return docSend;
        }



        private void tsmi_Format_Wrap_Click(object sender, EventArgs e)     //自动换行
        {
            try
            {
                if (tsmi_Format_Wrap.CheckState == CheckState.Checked)
                {
                    tssl_FormCount.Text = string.Format("   Successfully disable format wrap function ......");
                    tsmi_Format_Wrap.CheckState = CheckState.Unchecked;
                    DocForm df = (DocForm)this.ActiveMdiChild;
                    df.Sourse.WordWrap = false;
                }
                else
                {
                    tssl_FormCount.Text = string.Format("   Successfully enable format wrap function ......");
                    tsmi_Format_Wrap.CheckState = CheckState.Checked;
                    DocForm df = (DocForm)this.ActiveMdiChild;
                    df.Sourse.WordWrap = true;
                }
            }
            catch (Exception ex)
            {
                return;
            }
        }

        private void tsmi_Format_Font_Click(object sender, EventArgs e)     //字体大小设置
        {
            tssl_FormCount.Text = string.Format("   Enable word size setting ......");
            try
            {
                if (fontDialog1.ShowDialog() == DialogResult.OK && doc != null)
                {
                    DocForm df = (DocForm)this.ActiveMdiChild;
                    df.Sourse.SelectionFont = fontDialog1.Font;
                }
            }
            catch (Exception ex)
            {
                return;
            }
            tssl_FormCount.Text = string.Format("   Disable word size setting ......");
        }

        private void tsmi_Format_Colour_Click(object sender, EventArgs e)   // 字体颜色设置
        {
            tssl_FormCount.Text = string.Format("   Enable word color setting ......");
            try
            {
                if (colorDialog1.ShowDialog() == DialogResult.OK && doc != null)
                {
                    DocForm df = (DocForm)this.ActiveMdiChild;
                    df.Sourse.SelectionColor = colorDialog1.Color;
                }
            }
            catch (Exception ex)
            {
                return;
            }
        }



        private void tsmi_File_NewCreate_Click(object sender, EventArgs e)  //新建文件
        {
            wCount++;
            doc = new DocForm();
            listDocForm.Add(doc);

            doc.MdiParent = this;
            doc.Text = "文档" + wCount;
            doc.Show();

            if (wCount == 1)
            {
                doc.WindowState = FormWindowState.Maximized;
            }
            tssl_FormCount.Text = string.Format("   Successfully create file ......Current filename is ", this.MdiChildren.Length, doc.Text);
        }

        private void tsmi_File_Open_Click(object sender, EventArgs e)       //打开文件
        {
            tssl_FormCount.Text = string.Format("  Open file ......");
            doc = new DocForm();
            try
            {
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    RichTextBoxStreamType fileType = TrunFileType(openFileDialog1.FilterIndex);
                   
                //    MessageBox.Show("time after fileType");
                //    MessageBox.Show("file name is "+openFileDialog1.FileName);
                    wCount++;
                    doc = new DocForm(fileType, openFileDialog1.FileName, openFileDialog1.FilterIndex);
                    doc.MdiParent = this;
                    doc.Show();
                    listDocForm.Add(doc);
                 //   MessageBox.Show("time after listdocform");
                }
            }
            catch (Exception ex)
            {
                return;
            }
          //  MessageBox.Show("time to str");
            string str = openFileDialog1.FileName;
            string[] sArray = str.Split('\\');
            if (sArray.Length == 0) return;

            doc.Text = sArray[sArray.Length - 1];

            tssl_FormCount.Text = string.Format("   Successfully open file, the filename is  ", doc.Text);
            doc.WindowState = FormWindowState.Maximized;
        }

        private void tsmi_File_Save_Click(object sender, EventArgs e)       //保存文件
        {
            DocForm df = (DocForm)this.ActiveMdiChild;
            try
            {
                if (df.GetFilePath() == "")
                {
                    tssl_FormCount.Text = string.Format("   Please select save path ");
                    SaveFile(df);
                    //SaveDateToDateBase(df);
                    MessageBox.Show("save successfully");
                    tssl_FormCount.Text = string.Format("   save successfully ", doc.Text);
                }
                else
                {
                    RichTextBoxStreamType fileType = TrunFileType(df.GetFileTypeIndex());
                    df.Sourse.SaveFile(df.GetFilePath(), fileType);
                    MessageBox.Show("save successfully");
                    tssl_FormCount.Text = string.Format("   save successfully ", doc.Text);
                }

                //save the path to log
                saveLog(df.GetFilePath());



            }
            catch (Exception ex)
            {
                MessageBox.Show("Failure, save again！");
            }
        }

        private void saveLog(string savepath)
        {
            String path = System.Environment.CurrentDirectory + "\\log.txt";
            StreamReader rd = new StreamReader(path);
            string st = string.Empty;
            string[] content = { null, null, null };
            //if the path exists in the loop
            int count = 0;
            int exist = 0;
            while (!rd.EndOfStream && count < 2)
            {
                st = rd.ReadLine();



                if (st == savepath)
                { exist = 1; break; }
                ++count;
                content[count] = st;
                // MessageBox.Show("count is " + (count - 1) + " and " + content[count]);
            }
            rd.Close();

            //if the path is a new path
            if (exist == 0)
            {
                content[0] = savepath;
                int i = 0;
                StreamWriter sw = File.CreateText(path);
                sw.Write("");
                sw.Close();
                //   MessageBox.Show("there is " + (count + 1) + " and the content0: " + content[0] + " and content1: " + content[1] + " and content2" + content[2]);

                StreamWriter sww = new StreamWriter(path);
                while (i < 3 && content[i] != null)
                {
                    //       MessageBox.Show("in the danger loop to show content[" + i + " ] :  "+content[i]);
                    sww.WriteLine(content[i]);
                    //       MessageBox.
                    //           Show("danger end.");
                    i++;
                }

                sww.Close();
                //  MessageBox.
                //      Show("exist end.");
            }
            //  MessageBox.Show("check function end");
        }

        private void tsmi_File_OtherSave_Click(object sender, EventArgs e)  //另存为
        {
            tssl_FormCount.Text = string.Format("   Please select save path ");
            DocForm df = (DocForm)this.ActiveMdiChild;
            try
            {
                SaveFile(df);
                filePath = df.GetFilePath();
                //SaveDateToDateBase(df);
                MessageBox.Show("save successfully");
            }
            catch (Exception ex)
            {
                return;
            }
            tssl_FormCount.Text = string.Format("   Save successfully ", doc.Text);
            saveLog(df.GetFilePath());

        }

        /*     private void tsmi_File_SaveToDateBase_Click(object sender, EventArgs e)//保存到数据库
             {
                 try
                 {
                     DocForm df = (DocForm)this.ActiveMdiChild;
                     fileName = df.Text;
                     if (filePath == "")
                     {
                         filePath = Environment.CommandLine;
                     }
                     SaveDateToDateBase(df);
                 }
                 catch (Exception ex)
                 {
                     return;
                 }
             }*/

        private void tsmi_File_PrintPage_Click(object sender, EventArgs e)  //打印设置
        {
            tssl_FormCount.Text = string.Format("   Setting printer...... ");
            PrintDialog pd = new PrintDialog();
            pd.ShowDialog();
        }

        private void tsmi_File_PageSet_Click(object sender, EventArgs e)    //页面设置
        {
            tssl_FormCount.Text = string.Format("   Setting page...... ");
            pageSetupDialog1.Document = new PrintDocument();

            this.pageSetupDialog1.AllowMargins = true;
            this.pageSetupDialog1.AllowOrientation = true;
            this.pageSetupDialog1.AllowPaper = true;
            this.pageSetupDialog1.AllowPrinter = true;

            this.pageSetupDialog1.ShowDialog();
        }

        private void tsmi_File_Exit_Click(object sender, EventArgs e)       //退出程序
        {
            Application.Exit();
        }



        private void tsmi_Edit_Copy_Click(object sender, EventArgs e)   //复制
        {
            DocForm df = (DocForm)this.ActiveMdiChild;
            try
            {
                if (df.Sourse.SelectionLength > 0)
                {
                    df.Sourse.Copy();
                }
            }
            catch
            {
                return;
            }
            tssl_FormCount.Text = string.Format("   Copy successfully   ");
        }

        private void tsmi_Edit_Stick_Click(object sender, EventArgs e)  //粘贴
        {
            DocForm df = (DocForm)this.ActiveMdiChild;
            try
            {
                df.Sourse.Paste();
                tssl_FormCount.Text = string.Format("   Paste successfully   ");
            }
            catch (Exception ex)
            {
                return;
            }
        }

        private void tsmi_Edit_Cut_Click(object sender, EventArgs e)    //剪接
        {
            DocForm df = (DocForm)this.ActiveMdiChild;
            try
            {
                if (df.Sourse.SelectionLength > 0)
                {
                    df.Sourse.Cut();
                }
            }
            catch (Exception ex)
            {
                return;
            }
            tssl_FormCount.Text = string.Format("   Cut successfully   ");
        }

        private void tsmi_Edit_Delete_Click(object sender, EventArgs e) //删除
        {
            DocForm df = (DocForm)this.ActiveMdiChild;
            try
            {
                if (df.Sourse.SelectionLength > 0)
                {
                    df.Sourse.SelectedText = "";
                }
            }
            catch (Exception ex)
            {
                return;
            }
            tssl_FormCount.Text = string.Format("   Delete successfully   ");
        }

        private void tsmi_Edit_Cancel_Click(object sender, EventArgs e) //撤销
        {
            DocForm df = (DocForm)this.ActiveMdiChild;
            try
            {
                if (df.Sourse.CanUndo == true)
                {
                    df.Sourse.Undo();
                }
            }
            catch (Exception ex)
            {
                return;
            }
            tssl_FormCount.Text = string.Format("   Undo successfully   ");
        }

        private void tsmi_Edit_Find_Click(object sender, EventArgs e)   //查找
        {
            docSend = (DocForm)this.ActiveMdiChild;
            FindForm find = new FindForm();
            find.Show();
            tssl_FormCount.Text = string.Format("   Find for Editing   ");
        }



        private void tsmi_Edit_AllSelect_Click(object sender, EventArgs e)  //全选
        {
            try
            {
                DocForm df = (DocForm)this.ActiveMdiChild;
                df.Sourse.SelectAll();
                tssl_FormCount.Text = string.Format("   Already select all......   ");
            }
            catch (Exception ex)
            {
                return;
            }
        }

        private void tsmi_Edit_Date_Click(object sender, EventArgs e)   //日期时间
        {
            try
            {
                DocForm df = (DocForm)this.ActiveMdiChild;
                Clipboard.SetText(DateTime.Now.ToString());
                df.Sourse.Paste();
                tssl_FormCount.Text = string.Format("   Edit date......   ");
            }
            catch (Exception ex)
            {
                return;
            }
        }



        private void tsmi_Help_LookForHelp_Click(object sender, EventArgs e)    //帮助信息
        {
            tssl_FormCount.Text = string.Format("    Open help......");
            MessageBox.Show("Thanks for using, please contact the developer. ");
        }

        private void tsmi_Help_AboutTheSoft_Click(object sender, EventArgs e)   //关于软件信息
        {
            tssl_FormCount.Text = string.Format("    About this software......");
            MessageBox.Show("Software version：1.0\n\rDevelopers: Yan, Zhongyu, Yichen\n\rContact：xxxx@hotmail.com");
        }

        private void tsmi_Check_Statue_Click(object sender, EventArgs e)        //状态栏
        {
            try
            {
                if (tsmi_Check_Statue.CheckState == CheckState.Checked)
                {

                    tsmi_Check_Statue.CheckState = CheckState.Unchecked;
                    stasp_StatueBar.Visible = false;
                }
                else
                {
                    tsmi_Check_Statue.CheckState = CheckState.Checked;
                    stasp_StatueBar.Visible = true;
                    tssl_FormCount.Text = string.Format("   Enable status bar ");
                }
            }
            catch (Exception ex)
            {
                return;
            }
        }




        public void ExecuteSql(string sql)                  //执行sql语句
        {
            using (OleDbConnection conn = new OleDbConnection(_connectionString))
            {
                using (OleDbCommand command = new OleDbCommand())
                {
                    try
                    {
                        conn.Open();
                        command.Connection = conn;
                        command.CommandType = System.Data.CommandType.Text;
                        command.CommandText = sql;
                        command.ExecuteNonQuery();
                    }
                    catch (Exception ex)
                    {
                        conn.Close();
                    }
                }
            }
        }

        public DataTable ReadDataToDataTable(string sql)    //输出数据库数据
        {
            using (OleDbConnection conn = new OleDbConnection(_connectionString))
            {
                using (OleDbCommand command = new OleDbCommand())
                {

                    conn.Open();
                    command.Connection = conn;
                    command.CommandType = System.Data.CommandType.Text;

                    DataTable dt = new DataTable();
                    OleDbDataAdapter adapter = new OleDbDataAdapter();

                    command.CommandText = sql;
                    adapter.SelectCommand = command;
                    adapter.Fill(dt);
                    return dt;
                }
            }
        }

        public void SaveFile(DocForm df)                    //保存文件
        {
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.Filter = "文本文件（*.txt）|*.txt|RTF文件|*.rtf|所有文件（*.*）|*.*";

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                RichTextBoxStreamType fileType = TrunFileType(sfd.FilterIndex);
                doc.SetFileTypeIndex(sfd.FilterIndex);
                doc.SetFilePath(saveFileDialog1.InitialDirectory);
                df.Sourse.SaveFile(sfd.FileName, fileType);

                df.SetFilePath(sfd.FileName);
                oldFileType = fileType;
            }
            string str = df.GetFilePath();

            string[] sArray = str.Split('\\');
            fileName = sArray[sArray.Length - 1];

            for (int i = 0; i < sArray.Length - 1; i++)
            {
                filePath += sArray[i];
            }
        }

        public void SaveDateToDateBase(DocForm df)          //保存到数据库
        {
            try
            {
                DataTable dtPath = new DataTable();
                dtPath = ReadDataToDataTable("select fNumber,fName from tFilePath");

                DataTable dtContent = new DataTable();
                dtContent = ReadDataToDataTable("select fNumber,fName from tFileContent");

                if (dtPath.Rows.Count != 0)
                {
                    for (int i = 0; i < dtPath.Rows.Count; i++)
                    {
                        if (fileName == (Convert.ToString(dtPath.Rows[i]["fName"])))
                        {
                            int idPath = Convert.ToInt32(dtPath.Rows[i]["fNumber"]);
                            ExecuteSql(string.Format("update tFilePath set fPath='{0}', where fNumber='{1}'", filePath, idPath));
                        }
                        else
                            ExecuteSql(string.Format("insert into tFilePath(fName,fPath) values('{0}','{1}')", fileName, filePath));
                    }
                }
                else
                    ExecuteSql(string.Format("insert into tFilePath(fName,fPath) values('{0}','{1}')", fileName, filePath));


                if (dtContent.Rows.Count != 0)
                {
                    for (int i = 0; i < dtContent.Rows.Count; i++)
                    {
                        if (fileName == (Convert.ToString(dtContent.Rows[i]["fName"])))
                        {
                            int idContent = Convert.ToInt32(dtContent.Rows[i]["fNumber"]);
                            ExecuteSql(string.Format("update tFileContent set fContent='{0}',fDate='{1}', where fNumber='{2}'", df.Sourse.Text, DateTime.Now, idContent));
                        }
                        else
                            ExecuteSql(string.Format("insert into tFileContent(fName,fContent,fDate) values('{0}','{1}','{2}')", fileName, df.Sourse.Text, DateTime.Now));

                    }
                }
                else
                    ExecuteSql(string.Format("insert into tFileContent(fName,fContent,fDate) values('{0}','{1}','{2}')", fileName, df.Sourse.Text, DateTime.Now));
                MessageBox.Show("Successfully save to database！");
            }
            catch (Exception ex)
            {
                MessageBox.Show("Save failure！");
            }
        }

        public RichTextBoxStreamType TrunFileType(int i)   //数据转换
        {
            RichTextBoxStreamType fileType;
            switch (i)
            {
                case 1: fileType = RichTextBoxStreamType.PlainText;
                    break;
                case 2: fileType = RichTextBoxStreamType.RichText;
                    break;
                default: fileType = RichTextBoxStreamType.UnicodePlainText;
                    break;
            }
            return fileType;
        }

        private void tsmi_File_History_Click(object sender, EventArgs e)
        {

            addItems();


        }
        private void item1_Click(object sender, EventArgs e)
        {
            //MessageBox.Show("aha");
            string path = (string)this.item3.GetType().GetProperty("Text").GetValue(this.item1);

            showText(path);

        }

        private void addItems()
        {
            ToolStripMenuItem o = new ToolStripMenuItem();

            StreamReader rd = new StreamReader(System.Environment.CurrentDirectory + "\\log.txt");
            if (!rd.EndOfStream)
            {
                this.item1.GetType().GetProperty("Visible").SetValue(this.item1, true);
                this.item1.GetType().GetProperty("Text").SetValue(this.item1, rd.ReadLine());
            }
            if (!rd.EndOfStream)
            {
                this.item2.GetType().GetProperty("Visible").SetValue(this.item2, true);
                this.item2.GetType().GetProperty("Text").SetValue(this.item2, rd.ReadLine());
            }
            if (!rd.EndOfStream)
            {
                this.item3.GetType().GetProperty("Visible").SetValue(this.item3, true);
                this.item3.GetType().GetProperty("Text").SetValue(this.item3, rd.ReadLine());
            }
            rd.Close();
        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }
        [DllImport("kernel32.dll")]
        public static extern int WinExec(string exeName, int operType);

        private void copyFile(string sourcepath, string destpath)
        {

            while (!System.IO.File.Exists(destpath))
                System.IO.File.Create(destpath);
            // To copy a file to another location and  
            // overwrite the destination file if it already exists.
            System.IO.File.Copy(sourcepath, destpath, true);
          //  MessageBox.Show("copyFile success");



        }
        public enum ShowCommands : int
        {
            SW_HIDE = 0,
            SW_SHOWNORMAL = 1,
            SW_NORMAL = 1,
            SW_SHOWMINIMIZED = 2,
            SW_SHOWMAXIMIZED = 3,
            SW_MAXIMIZE = 3,
            SW_SHOWNOACTIVATE = 4,
            SW_SHOW = 5,
            SW_MINIMIZE = 6,
            SW_SHOWMINNOACTIVE = 7,
            SW_SHOWNA = 8,
            SW_RESTORE = 9,
            SW_SHOWDEFAULT = 10,
            SW_FORCEMINIMIZE = 11,
            SW_MAX = 11
        }
        [DllImport("shell32.dll")]
        static extern IntPtr ShellExecute(
            IntPtr hwnd,
            string lpOperation,
            string lpFile,
            string lpParameters,
            string lpDirectory,
            ShowCommands nShowCmd);


       
        private void button1_Click(object sender, EventArgs e)
        {
            //put the current docform to the a.txt
            if (this.doc == null )
                MessageBox.Show("Please choose one file or open a new file.");
            else
            {
                if (System.IO.File.Exists(System.Environment.CurrentDirectory + "\\files\\ConsoleApplication1\\ConsoleApplication1\\ConsoleApplication1.obj"))
                {
                  //  MessageBox.Show("delete consoleapp");
                    System.IO.File.Delete(System.Environment.CurrentDirectory + "\\files\\ConsoleApplication1\\ConsoleApplication1\\ConsoleApplication1.obj");
                }
                if (System.IO.File.Exists(System.Environment.CurrentDirectory + "\\files\\ConsoleApplication1\\ConsoleApplication1\\result.txt"))
                {
                   // MessageBox.Show("delete result");
                   
                    System.IO.File.Delete(System.Environment.CurrentDirectory + "\\files\\ConsoleApplication1\\ConsoleApplication1\\result.txt");
                }
                if (System.IO.File.Exists(System.Environment.CurrentDirectory + "\\files\\ConsoleApplication1\\ConsoleApplication1\\result.exe"))
                {
                  //  MessageBox.Show("delete result.exe");
                    System.IO.File.Delete(System.Environment.CurrentDirectory + "\\files\\ConsoleApplication1\\ConsoleApplication1\\result.exe");
                }
                if (System.IO.File.Exists(System.Environment.CurrentDirectory + "\\files\\PLT2\\result.cpp"))
                {
                  //   MessageBox.Show("delete result.cpp!");
                    System.IO.File.Delete(System.Environment.CurrentDirectory + "\\files\\PLT2\\result.cpp");
                }
                try
                {
                    SaveFileDialog sfd = new SaveFileDialog();
                    DocForm df = (DocForm)this.doc;

                    //  sfd.Filter = "文本文件（*.txt）|*.txt|RTF文件|*.rtf|所有文件（*.*）|*.*";

                    sfd.FileName = System.Environment.CurrentDirectory + "\\files\\PLT2\\a.txt";
                    RichTextBoxStreamType fileType = TrunFileType(1);
                    this.doc.SetFileTypeIndex(1);
                    this.doc.SetFilePath(sfd.FileName);
                    df.Sourse.SaveFile(sfd.FileName, fileType);

                    df.SetFilePath(sfd.FileName);
                    oldFileType = fileType;
                   // MessageBox.Show("already saved ");
                    //ouput the cpp file
                    string path = System.Environment.CurrentDirectory + "\\files\\PLT2\\codegen.exe";
                    //MessageBox.Show(path);


                    if ((int)ShellExecute(Handle, "open", path, null, System.Environment.CurrentDirectory + "\\files\\PLT2\\", 0) > 32)  MessageBox.Show("The program is running well.Waiting....");
                    if (!System.IO.File.Exists(System.Environment.CurrentDirectory + "\\files\\PLT2\\result.cpp"))
                        MessageBox.Show("code generation fails.There is no .cpp file generated.");

                    else
                    {
                        StreamReader sr = new StreamReader(System.Environment.CurrentDirectory + "\\files\\PLT2\\result.cpp");
                        if (sr.ReadLine() == null)
                        {
                            this.richTextBox1.GetType().GetProperty("Text").SetValue(this.richTextBox1, "Fail! Error exists! Please check again!");
                        }
                        else
                        {
                            //move and substitute the cpp file
                            copyFile(System.Environment.CurrentDirectory + "\\files\\PLT2\\result.cpp", System.Environment.
                            CurrentDirectory + "\\files\\ConsoleApplication1\\ConsoleApplication1\\ConsoleApplication1.cpp");
                          

                            System.Diagnostics.Process p = new System.Diagnostics.Process();
                            p.StartInfo.FileName = "cmd.exe";//要执行的程序名称
                            p.StartInfo.UseShellExecute = false;
                            p.StartInfo.RedirectStandardInput = true;//可能接受来自调用程序的输入信息
                            p.StartInfo.RedirectStandardOutput = true;//由调用程序获取输出信息
                            p.StartInfo.CreateNoWindow = true;//不显示程序窗口
                            p.StartInfo.Arguments = "/c cd files//ConsoleApplication1//ConsoleApplication1&&.\\VC\\vcvarsall.bat&&.\\Common7\\IDE\\devenv.com /RunExit ConsoleApplication1.vcxproj";

                            p.Start();//启动程序

                            //produce the result.txt file 
                            /*  Process.Start("cmd.exe", "/c cd files//ConsoleApplication1//ConsoleApplication1&&.\\VC\\vcvarsall.bat&&.\\VC\\bin\\cl.exe"+
                                  " stdafx.cpp ConsoleApplication1.cpp&&.\\VC\\bin\\link.exe /Fc result.exe stdafx.obj ConsoleApplication1.obj");
                              Process.Start("cmd.exe", "/c cd files//ConsoleApplication1//ConsoleApplication1&&.\\VC\\vcvarsall.bat&&.\\Common7\\IDE\\devenv.com /runExit ConsoleApplication1.vcxproj");
                           */
                            //draw the picture 
                            string filepath = System.Environment.
                            CurrentDirectory + "\\files\\ConsoleApplication1\\ConsoleApplication1\\result.txt";
                          
                            while (!System.IO.File.Exists(filepath))
                            {
                                MessageBox.Show("Wait.....Almost done!");
                            }
                            //    MessageBox.Show("out while");
                           
                                
                               // this.richTextBox1.GetType().GetProperty("Text").SetValue(this.richTextBox1, "Fail! Error exists! Please check again!");
                            
                            
                                draw(filepath);
                                // (string)this.item3.GetType().GetProperty("Text").GetValue(this.item3);
                                this.richTextBox1.GetType().GetProperty("Text").SetValue(this.richTextBox1, "success!");
                           
                        } sr.Close();
                    }
                    
                }
                catch (Exception exce)
                {
                    MessageBox.Show("there is an error! ");
                    this.richTextBox1.GetType().GetProperty("Text").SetValue(this.richTextBox1, "fail!");
                }
            } 
            
        }
        private void draw(string path)
        {
            
           
            if(!System.IO.File.Exists(path))
            {
                MessageBox.Show("The txt file does not exist! Compile again!");
               
            }
            
            else
            {
               // MessageBox.Show("before streamreader");
                StreamReader rd = new StreamReader(path);
                if(rd.ReadLine() == null)
                {
                    MessageBox.Show("empty result.txt");
                }
                else{
                drawform = new DrawForm();
                drawform.Show();

                char[] delimiters = new char[] { ' ' };
                string line;
                while ((line = rd.ReadLine()) != null)
                {

                    // MessageBox.Show(line);
                    string[] parts = line.Split(delimiters, StringSplitOptions.RemoveEmptyEntries);


                    if (parts[0] == "Line")
                    {
                        // MessageBox.Show("it is a line.x1 is " + parts[1] + " y1 is " + parts[2] + " x2 is " + parts[3] + " y2 is " + parts[4]);
                        drawform.drawLine(float.Parse(parts[1]), float.Parse(parts[2]), float.Parse(parts[3]), float.Parse(parts[4]), 2);
                        //  drawform.drawLine(float.Parse(parts[1]), float.Parse(parts[2]), float.Parse(parts[3]), float.Parse(parts[4]),int.Parse(parts[5]));
                    }
                    else if (parts[0] == "Circle")
                    {
                        drawform.drawCircle(float.Parse(parts[1]), float.Parse(parts[2]), float.Parse(parts[3]), 1);
                    }
                    else if (parts[0] == "Point")
                    {
                       // MessageBox.Show("point: x: " + parts[1] + " y: " + parts[2]);
                        drawform.drawPoint(float.Parse(parts[1]), float.Parse(parts[2]));

                    }
                    else if (parts[0] == "END")
                    {
                        break;
                    }
                    else { }

                }
                }
                rd.Close();
            }
        }


        private void tsmi_Edit_Click(object sender, EventArgs e)
        {

        }

        private void tsmi_Help_Click(object sender, EventArgs e)
        {

        }

        private void MainForm_Load(object sender, EventArgs e)
        {

        }

        private void item2_Click(object sender, EventArgs e)
        {
            string path = (string)this.item3.GetType().GetProperty("Text").GetValue(this.item2);

            showText(path);
        }

        private void item3_Click(object sender, EventArgs e)
        {
            
            string path = (string)this.item3.GetType().GetProperty("Text").GetValue(this.item3);

            showText(path);

           
            
        }

        private void showText(string path)
        {
            StreamReader rd = new StreamReader(path);
            String str = rd.ReadToEnd();


            openFileDialog1.FileName = path;
            RichTextBoxStreamType fileType = TrunFileType(openFileDialog1.FilterIndex);
            //  MessageBox.Show("file name is " + openFileDialog1.FileName);
            ///  wCount++;
            doc = new DocForm(RichTextBoxStreamType.PlainText, openFileDialog1.FileName, openFileDialog1.FilterIndex);
            doc.MdiParent = this;
            doc.Show();
            listDocForm.Add(doc);
            doc.WindowState = FormWindowState.Maximized;
            
        }








    }
}

     

    


